import fetchData from "./fetchFun";
import createInstance from "./instance";

const createFetch = ({ requestConfig, loading }) => {
  let instance = createInstance({ requestConfig });

  if (!requestConfig) throw "需要 requestConfig";

  //将封装的数据分发下来
  const fetch = ["get", "post", "delete", "put", "patch"].reduce((pre, cur) => {
    return {
      ...pre,
      [cur](url, data, config) {
        return fetchData(instance, { method: cur, url, data, config }, loading); // 请求方式
      },
    };
  }, {});

  return { fetch, instance };
};

export default createFetch;
